# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..1\n"; }
END {print "not ok 1\n" unless $loaded;}
use GGI;
use GGI::Mode;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

print "2..";
$vis = new GGI "display-bogus";
print "2\n";
if (defined($vis)) {
    print "not OK 2\n";
}
else {
    print "OK 2\n";
}

print "3..";
$vis = new GGI;
print "3\n";
if (defined($vis)) {
    print "OK 3\n";
}
else {
    print "Not OK 3\n";
    die "Default GGI display may not be functional; must be for tests.\n";
}

print "4..4\nStringification of visual follows this line:\n$vis\n";

print "5..5\n";
$mode = $vis->checkmode;
print "auto-checkmode yields $mode\n";
if ($mode = $vis->checkmode($mode)) {
    print "not OK 5\n";
    print "status = " . int($mode) . "\n";
    die "Default GGI mode may not be functional; must be for tests.\n";
}
else {
    print "mode = " . $mode . "\nOK 5\n";
}

print "6..";
if (not defined($vis->setmode->status) or $vis->setmode->status) {
    print "6\nnot OK 5\n";
    die "Default GGI mode may not be functional; must be for tests.\n";
}
else {
    print "6\nmode = " . $vis->mode . "\nOK 5\n";
}

print "7..";
($l, $t, $r, $b) = $vis->clip();
$vis->clip(10,11,12,13);
($nl, $nt, $nr, $nb) = $vis->clip();
$vis->clip($l, $t, $r, $b);
print "7\n";
print "Original clip rectangle was set to $l, $t, $r, $b\n";
unless ($nl == 10 and $nt == 11 and $nr == 12 and $nb == 13) {
    print "After set, clip rectangle was set to $nl, $nt, $nr, $nb\n";
    print "not OK 7\n";
}
else {
    print "OK 7\n";
}

$vis->palette;

$vis->bg(0);
$vis->fg(1);


for ($x = 0; $x < 100; $x++) {
    $vis->pixel($x, 4);
    $vis->pixel($x, 6, $x);
    $vis->hline(0, $x + 8, 49);
    $vis->hline(50, $x + 8, 49);
    $vis->vline($x + 100, 0, 49);
    $vis->vline($x + 100, 50, 49);
    $vis->line(100, 100, $x + 100, 200 - $x);

}

for ($i = 0; $i < 100; $i+= 2) {
    $vis->fg($i);
    $vis->box($i/2, 100 + $i/2, 100 - $i, 100 - $i); 
}

$vis->box(0,100,50,50,50,150);

$vis->puts(0,250,"Hello World!");

$Foo = <>;

